#!/usr/bin/env python
# $Id: psst.py,v 1.1 2006/04/03 14:31:58 cvs Exp $

# Output distribution of packet transmission rates

import tcpdumpread,sys,signal
from fpformat import *

signal.signal(signal.SIGPIPE, signal.SIG_DFL)  # To fix "broken pipe" weirdness 

def printUsage():
  print >> sys.stderr, "Usage: psst.py q a maxk [dens]"
  print >> sys.stderr, "     [dens] means plot density not dist"                    
  sys.exit()  


def calcBinom(k, i):
  if i == 0 or k == i:
    return 1
#  print "calc",k,"choose",i
  bin= 1
  for j in range(1,k+1-i):
#    print "times",j+i,"div by",i
    bin*= float(j+i)/j
#  print k,i,bin
  return bin

# Main starts here

narg= len(sys.argv)
if narg != 4:
  printUsage()
try:
  q= float(sys.argv[1])
  a= float(sys.argv[2])
  maxk= int(sys.argv[3])    
except ValueError:
  printUsage()
for k in range (1,maxk+1):
  sum= 0.0
  for i in range (0,k+1):
    term= calcBinom(k,i)/(a*pow(float(a)/q,i) - 1.0)
    if i%2 == 1:
      sum -= term
    else:
      sum += term
  print k, sum
